"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactNative = require("react-native");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const _module = _reactNative.NativeModules.Clusterer;

if (_module && typeof _module.install === 'function') {
  _module.install();
} // @ts-ignore


const clusterer = global.clustererModule;

class Supercluster {
  constructor(points, options) {
    _defineProperty(this, "id", void 0);

    if (!clusterer) {
      throw new Error(`The package 'react-native-cryptopp' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
        ios: "- You have run 'pod install'\n",
        default: ''
      }) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo managed workflow\n');
    } // generate random id


    this.id = `${Math.floor(Math.random() * Math.floor(Math.random() * Date.now()))}`;
    clusterer.init(this.id, points, options);
  }

  getClusters(bbox, zoom) {
    return clusterer.getClusters(this.id, bbox, zoom);
  }

  getTile(x, y, z) {
    return {
      features: clusterer.getTile(this.id, x, y, z)
    };
  }

  getChildren(clusterId) {
    return clusterer.getChildren(this.id, clusterId);
  }

  getLeaves(clusterId, limit, offset) {
    return clusterer.getLeaves(this.id, clusterId, limit !== null && limit !== void 0 ? limit : 10, offset !== null && offset !== void 0 ? offset : 0);
  }

  getClusterExpansionZoom(clusterId) {
    return clusterer.getClusterExpansionZoom(this.id, clusterId);
  }

  destroy() {
    clusterer.destroyCluster(this.id);
  }

}

exports.default = Supercluster;
//# sourceMappingURL=index.js.map